
unit tree; //Version 1.17 11/2014

{
 Ce programme permet de creer graphiquement une figure de 8 LED qui s'affiche
 sur une image de sapin de Nol et de gnrer la routine C qui s'intgrera dans
 le programme C++ pour les microcontroleurs 8 BIT ATTiny13 /45/85 grce  deux
 programmes (presques semblables) dvelopps pour Arduino 1.05-r2
 ou Amtel Studio 6.1 le fichier ZIP contient une aide en PDF pour ce programme
 le programme pour Arduino et pour Amtel Studio, le lien pour tlcharger
 les librairie permettant de programmer un ATTiny avec Arduino.

 This program allows you to create graphically a figure-8 LED will be displayed
on a picture of a Christmas tree and generate the C routine that will fit in
C ++ program for microcontrollers 8 BIT ATtiny 13 / 45/85 with two
programs (similar presques) developed for Arduino 1.06 or
Amtel Studio 6.1 . The ZIP file contains a PDF using this program
program for Arduino and Atmel Studio, the link to download the library
to program a ATtiny with Arduino.

*** Certaines routines proviennent des tutos du site developpez.com ***
*** Some routines from tutorials site developpez.com                ***
Voir  cette adresse  see this link:
http://www.developpez.net/forums/f15/environnements-developpement/delphi/
}

{
-------------------------------------------------------------------------
         ENCODAGE DES COULEURS RGB (256 couleurs) EN DECIMAL
*************************************************************************
 EX: RF pour RougeFonc
 Rouge(R)Fonc(F)Clair(C) idem pour les autres
**********************couleurs utilises*********************************
RF(100,00,00) RC(255,00,00) OF(255,102,00) OC(255,153,51) JF(204,204,51)
JC(255,255,51) BLF(153,153,153) BLC(255,255,255) BF(00,00,153)
BC(102,255,255) VF(00,153,00) VC(00,255,00)

==================== COORDONNEES x1,y1 DES LEDs  ========================
 390,110- 353,164- 426,164- 390,220- 314,266- 475,266- 273,340- 503,340
-------------------------------------------------------------------------
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Jpeg, StdCtrls, Buttons, ImgList, Spin, ComCtrls,
  FileCtrl;

type
    TForm1 = class(TForm)

    Tree: TImage;           //pour affichage du sapin en arrire plan
                           // to display the tree in the background
    PaintBox1: TPaintBox;  //pour dessin des LEDs sur le sapin en avant plan
                           // Drawing LEDs on the tree in the foreground
    ImageList1: TImageList;

    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Edit1: TEdit;
    NB_Trames: TMemo;
    UpDown1: TUpDown;
    Edit2: TEdit;
    MilliSec: TMemo;
    UpDown2: TUpDown;
    FigureType: TMemo;
    Nom: TEdit;
    Save: TButton;
    ToogleLEd: TMemo;
    Memo1: TMemo;
    BL1: TEdit;
    BL2: TEdit;
    BL3: TEdit;
    BL4: TEdit;
    BL5: TEdit;
    BL6: TEdit;
    BL7: TEdit;
    BL8: TEdit;
    UpDown3: TUpDown;
    UpDown4: TUpDown;
    UpDown5: TUpDown;
    UpDown6: TUpDown;
    UpDown7: TUpDown;
    UpDown8: TUpDown;
    UpDown9: TUpDown;
    UpDown10: TUpDown;
    Test: TButton;
    Button1: TButton;
    procedure TreeClick (Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure BL1Change(Sender: TObject);
    procedure BL2Change(Sender: TObject);
    procedure BL3Change(Sender: TObject);
    procedure BL4Change(Sender: TObject);
    procedure BL5Change(Sender: TObject);
    procedure BL6Change(Sender: TObject);
    procedure BL7Change(Sender: TObject);
    procedure BL8Change(Sender: TObject);
    procedure TestClick(Sender: TObject);




    private
    { Dclarations prives }


    procedure boule;  //allume teint les LEDs
                                      // setting the LED ON/OFF
    procedure figure (NomAnim : String);


    public

    { Dclarations publiques }
   end;


   Type TTestFig = Record
   FigureLED :  Array [0..9] of Integer;
   BlinkOrder: Array [0..8] of Integer;
   Ordre     : Array [0..8] of Integer;
   end;



 const
 { couleur RGB des LED et coordonnes xy
   x2 = x + 15, y2 = y + 15
  RGB LED's colors and xy coordonates
   x2 = x + 15, y2 = y + 15              }

  noir: Array [1..3] of integer = (0,0,0);
  blanc: Array [1..3] of integer = (255,255,255);
  blancxy: Array [1..2] of integer = (390,110 );
  vert: Array [1..3] of integer =(0,255,0);
  vertxy: Array [1..2] of integer = (353,164);
  vert1xy: Array [1..2] of integer = (426,164);
  bleu: Array [1..3] of integer =(102,255,255);
  bleuxy: Array [1..2] of integer = (390,220);
  jaune: Array [1..3] of integer =(255,255,51);
  jaunexy: Array [1..2] of integer = (314,266);
  jaune1xy: Array [1..2] of integer = (475,266);
  orange: Array [1..3] of integer =(255,153,51);
  orangexy: Array [1..2] of integer = (273,340);
  orange1xy: Array [1..2] of integer = (503,340);
  rouge: Array [1..3] of integer =(255,0,0);
  rougexy: Array [1..2] of integer = (273,340);
  rouge1xy: Array [1..2] of integer = (503,340);

  var
  Form1 : TForm1;
  CoulF,CoulC: Tcolor;
  x1,y1,x2,y2 : integer;
  prem_pass,Tag1,Tag2,Tag3,Tag4,Tag5,Tag6,Tag7,Tag8, Cvt : Integer;
  BL0,BL1,BL2,BL3,BL4,BL5,BL6,BL7,BL8 : Integer;
  Allum     : boolean;
  Tx         : String;
  Fig, Blink : TTestFig;


  implementation

{$R *.dfm}

function LEDcontrol(c: array of integer):integer;
 var
 r,g,b : integer;
 begin
 r := c[0];
 g := c[1];
 b := c[2];
 result := RGB(r,g,b);
 end;

function LEDposition(p: array of integer):integer;
 begin
 x1 := p[0];
 y1 := p[1];
 x2 := x1 +15;
 y2 := y1 +15;
 //result := x1;
 //result := x2;
 //result := y1;
 result := y2;
 end;


{=========================================================================}


procedure TForm1.figure(NomAnim : String);
 Var
 Trame : TextFile;

 Begin
      {*** Creation de la procedure pour Arduino ou Amtel Studio ***}
 AssignFile(Trame,NomAnim +'.txt');   { creation du fichier Animation.txt }
 Rewrite(Trame);                      { et ouverture en ecriture          }
 Write(Trame,'SomeOne (');            { enregistrement de la procdure    }
 Write(Trame,Fig.FigureLED[8]);           { Nombre de repetition de la figure }
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[0]);          { ON/OFF et position de FigureLED[0]}
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[1]);
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[2]);
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[3]);
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[4]);
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[5]);
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[6]);
 Write(Trame,',');
 Write(Trame,Blink.BlinkOrder[7]);
 Write(Trame,',');
 Write(Trame,Fig.FigureLED[9]);   {Delais d'affichage de la figure en miliSec}
 WriteLn(Trame,');     //'+ Nom.Text);  { enregistrement du nom de figure}
 CloseFile(Trame);
 end;

procedure TForm1.Button1Click(Sender: TObject);  {Reset de la figure}
var
Rst: byte;
begin
 Tx := '8';

 Fig.FigureLED[8]:= 0;
 Fig.FigureLED[9]:= 0;

 for Rst := 0 to 8 do
 begin
 Blink.BlinkOrder[Rst]:= 8;
 Blink.ordre[Rst] := 8;
 end;
 BL1.Text := Tx;
 BL2.Text := Tx;
 BL3.Text := Tx;
 BL4.Text := Tx;
 BL5.Text := Tx;
 BL6.Text := Tx;
 BL7.Text := Tx;
 BL8.Text := Tx;
 Edit1.Text := Tx;
 Edit2.Text := Tx;
end;

procedure TForm1.boule;
{..Test de la figure de LEDs avant enregistrement..}
 Var
 tempo,i,j,k, repAff, bcl  : integer;

 begin
 tempo := Fig.FigureLED[9];
 repAff:= Fig.FigureLED[8];

  for i := 0 to 7 do
  begin
  j := Blink.BlinkOrder[i];
  Blink.ordre[i] := j;
  end;
  for bcl := 1 to repAff do // test la figure de LED
  Begin
  for i := 0 to 7 do
  begin
  k:= Blink.ordre[i];
  case k of
      (0) and not (8):
       begin
       LEDposition(blancxy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(blanc);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(blanc);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
     (1) and not (8):
       begin
       LEDposition(vertxy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(vert);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(vert);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
     (2) and not (8):
        begin
       LEDposition(vert1xy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(vert);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(vert);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
     (3) and not (8):
       begin
       LEDposition(bleuxy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(bleu);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(bleu);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
     (4) and not (8):
       begin
       LEDposition(jaunexy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(jaune);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(jaune);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
     (6) and not (8):
       begin
       LEDposition(jaune1xy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(jaune);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(jaune);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
    (5) and not (8):
       begin
       LEDposition(rougexy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(rouge);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(rouge);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
    (7) and not (8):
       begin
       LEDposition(rouge1xy);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(noir);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       PaintBox1.Canvas.Pen.Color := LEDcontrol(rouge);
       PaintBox1.Canvas.Brush.Color := LEDcontrol(rouge);
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
       Sleep (tempo);
       end;
    // 8: Sleep (tempo);
       end;
    end;
    end;
  end;


procedure TForm1.TreeClick(Sender: TObject);

var
cpt : byte;

begin

{*** Affichage du sapin (BMP) dans un Canvas 640x480 256 couleurs ***}
Tree.Canvas.LineTo(Form1.ClientWidth , Form1.ClientHeight);
for cpt := 0 to 9 do                  {  initialise le tableau de LED a 0 }
Fig.FigureLED[cpt] := 0;
end;

procedure  TForm1.SpeedButton1Click(Sender: TObject);//LED BLANCHE
begin
      {Blanc}
      CoulF := LEDcontrol(noir);
      CoulC := LEDcontrol(blanc);
     // x1:= 390; y1 := 110;
     LEDposition(blancxy);
  with SpeedButton1 do
    begin
      if Tag1 = 0 then
      begin
        Tag1   := 1;
        Blink.FigureLED[1] := 8;
        Glyph := Nil;
        ImageList1.GetBitmap(6, Glyph);
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag1   := 0;
        Blink.FigureLED[1] :=3;
        Glyph := Nil;
        ImageList1.GetBitmap(7, Glyph);
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);// LED VERTE
begin
     {Vert}
      CoulF := LEDcontrol(noir);
      CoulC := LEDcontrol(vert);
      //x1:= 353; y1 := 164;
     LEDposition(vertxy);
     with SpeedButton2 do
    begin
      if Tag2 = 0 then
      begin
        Tag2   := 1;
        Blink.FigureLED[2] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(10, Glyph);
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag2   := 0;
        Blink.FigureLED[2] :=5;
        Glyph := Nil;
        ImageList1.GetBitmap(11, Glyph);
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
 end;

procedure TForm1.SpeedButton3Click(Sender: TObject); // LED VERTE
begin
     {Vert}
      CoulF := LEDcontrol(noir);
      CoulC := LEDcontrol(vert);
      //x1:= 426; y1 := 164;
      LEDposition(vert1xy);
     with SpeedButton3 do
    begin
      if Tag3 = 0 then
      begin
        Tag3   := 1;
        Blink.FigureLED[3] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(10, Glyph);
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag3   := 0;
        Blink.FigureLED[3] :=5;
        Glyph := Nil;
        ImageList1.GetBitmap(11, Glyph);
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
end;

procedure TForm1.SpeedButton4Click(Sender: TObject); //LED BLEUE
begin
      CoulF := LEDcontrol(noir);
      CoulC := LEDcontrol(bleu);
      //x1:= 390; y1 := 220;
     LEDposition(bleuxy);
with SpeedButton4 do
    begin
      if Tag4 = 0 then
      begin
        Tag4   := 1;
        Blink.FigureLED[4] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(8, Glyph);
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag4   := 0;
        Blink.FigureLED[4] :=4;
        Glyph := Nil;
        ImageList1.GetBitmap(9, Glyph);
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
 end;

procedure TForm1.SpeedButton5Click(Sender: TObject); // LED JAUNE
begin
{Jaune}
      CoulF := LEDcontrol(noir);
      CoulC := LEDcontrol(jaune);
      //x1:= 314; y1 := 266;
     LEDposition(jaunexy);
  with SpeedButton5 do
    begin
      if Tag5 = 0 then
      begin
        Tag5   := 1;
        Blink.FigureLED[5] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(4, Glyph);
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag5   := 0;
        Blink.FigureLED[5] :=5;
        Glyph := Nil;
        ImageList1.GetBitmap(5, Glyph);
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
 end;


procedure TForm1.SpeedButton6Click(Sender: TObject);  //LED ROUGE
begin
CoulF := 0;CoulC :=0;
        {Rouge}
         CoulF := LEDcontrol(noir);
        CoulC := LEDcontrol(rouge);
        //x1:= 273; y1 := 340;
        LEDposition(rougexy);

  with SpeedButton6 do
    begin
      if Tag7 = 0 then
      begin
        Tag7   := 1;
        Blink.FigureLED[6] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(0, Glyph);// LED teinte
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag7   := 0;
        Blink.FigureLED[6] :=6;
        Glyph := Nil;
        ImageList1.GetBitmap(1, Glyph); // LED allume
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
end;

 procedure TForm1.SpeedButton7Click(Sender: TObject);    //LED JAUNE
begin
{Jaune}
      CoulF := LEDcontrol(noir);
      CoulC := LEDcontrol(jaune);
      //x1:= 475; y1 := 266;
     LEDposition(jaune1xy);
  with SpeedButton7 do
    begin
      if Tag6 = 0 then
      begin
        Tag6   := 1;
        Blink.FigureLED[7] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(4, Glyph);
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag6   := 0;
        Blink.FigureLED[7] :=7;
        Glyph := Nil;
        ImageList1.GetBitmap(5, Glyph);
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
 end;


procedure TForm1.SpeedButton8Click(Sender: TObject);  //LED ROUGE
begin
CoulF := 0;CoulC :=0;
        {Rouge}
        CoulF := LEDcontrol(noir);
        CoulC := LEDcontrol(rouge);
        //x1:= 503; y1 := 340;
        LEDposition(rouge1xy);
  with SpeedButton8 do
    begin
      if Tag8 = 0 then
      begin
        Tag8   := 1;
        Blink.FigureLED[8] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(0, Glyph);// LED teinte
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag8   := 0;
        Blink.FigureLED[8] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(1, Glyph); // LED allume
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
end;

{begin
      //Orange
      CoulF := RGB(255,102,0);
      CoulC := RGB(255,153,51);
      x1:= 503; y1 := 340;
      x2 := x1 +15; y2 := y1 +15;
      with SpeedButton8 do
    begin
      if Tag8 = 0 then
      begin
        Tag8   := 1;
        Blink.FigureLED[7] :=8;
        Glyph := Nil;
        ImageList1.GetBitmap(2, Glyph);// LED teinte
       PaintBox1.Canvas.Pen.Color := CoulF;
       PaintBox1.Canvas.Brush.Color := CoulF;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end
      else
      begin
        Tag8   := 0;
        Blink.FigureLED[7] :=7;
        Glyph := Nil;
        ImageList1.GetBitmap(3, Glyph); // LED allume
        PaintBox1.Canvas.Pen.Color := CoulC;
       PaintBox1.Canvas.Brush.Color := CoulC;
       PaintBox1.Canvas.Brush.Style := bsSolid;
       PaintBox1.Canvas.Ellipse(x1,y1,x2,y2);
      end;
    end;
end;  }

procedure TForm1.Edit1Change(Sender: TObject);
begin
Cvt := StrtoInt (Edit1.Text);
Fig.FigureLED[8] := Cvt;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
Cvt := StrtoInt (Edit2.Text);
Fig.FigureLED[9] := Cvt;
end;

procedure TForm1.SaveClick(Sender: TObject);
begin
Figure(Nom.Text);
end;

procedure TForm1.BL1Change(Sender: TObject);
begin
BL0 := StrtoInt (BL1.Text);
Blink.BlinkOrder[0] := BL0;
end;

procedure TForm1.BL2Change(Sender: TObject);
begin
BL0 := StrtoInt (BL2.Text);
Blink.BlinkOrder[1] := BL0;
end;

procedure TForm1.BL3Change(Sender: TObject);
begin
BL0 := StrtoInt (BL3.Text);
Blink.BlinkOrder[2] := BL0;
end;

procedure TForm1.BL4Change(Sender: TObject);
begin
BL0 := StrtoInt (BL4.Text);
Blink.BlinkOrder[3] := BL0;
end;

procedure TForm1.BL5Change(Sender: TObject);
begin
BL0 := StrtoInt (BL5.Text);
Blink.BlinkOrder[4] := BL0;
end;

procedure TForm1.BL6Change(Sender: TObject);
begin
BL0 := StrtoInt (BL6.Text);
Blink.BlinkOrder[5] := BL0;
end;

procedure TForm1.BL7Change(Sender: TObject);
begin
BL0 := StrtoInt (BL7.Text);
Blink.BlinkOrder[6] := BL0;
end;

procedure TForm1.BL8Change(Sender: TObject);
begin
BL0 := StrtoInt (BL8.Text);
Blink.BlinkOrder[7] := BL0;
end;

procedure TForm1.TestClick(Sender: TObject);
begin
boule;
end;



end.



